#include <dos.h>
#include <io.h>
#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <sbc.h>
#include <wgtjoy.h>


#define ENGLISH 1
#define GERMAN 2
extern int language;

FILE *config;
char ch;
int r;
joystick joy;
int joystickon=0,soundon=0;

void calibratejoy(void)
{
	if (wcheckjoystick())
		{

               if (language==ENGLISH)
		printf("\nJoystick found... Calibrating\n");
               else
                printf("\nJoystick gefunden... kalibrieren\n");

		winitjoystick(&joy, 0);

               if (language==ENGLISH)
		printf("Move joystick to upper left and press fire:\n");
               else
                printf("Joystick nach oben links und Feuer drcken.\n");

		wcalibratejoystick(&joy);

               if (language==ENGLISH)
		printf("Move joystick to lower right and press fire:\n");
               else
                printf("Joystick nach unten rechts und Feuer drcken.\n");

		wcalibratejoystick(&joy);
               if (language==ENGLISH)
		printf("\n\nJoystick Calibrated.");
               else printf("\n\nJoystick kalibriert.");

		putw(1,config);		// joystick on
		putw(joy.port,config);
		putw(joy.cenx,config);
		putw(joy.ceny,config);
		putw(joy.xrange,config);   
		putw(joy.yrange,config);
		putw(joy.scale,config);

		}

	else {
               if (language==ENGLISH)
		printf("No joystick found! Sorry!\n");
              else printf("Kein Joystick gefunden. Sorry!\n");
	}
}

void checkconfig(void)
{
int gs;
textmode(C80);
clrscr();
if (access("wq.cfg",0)==-1)
 {
if (language==ENGLISH)
 printf("Configuring World Quest");
else
 printf("Konfiguriere World Quest");

 config=fopen("wq.cfg","wb");
if (language==ENGLISH)
 printf("\n\nDo you want to use a joystick? (Y/N)");
else
 printf("\n\nMchten Sie den Joystick benutzen? (J/N)");

 ch=toupper(getche());
if ( ((language==ENGLISH)& (ch=='Y')) | ((language==GERMAN) & (ch=='J')) )
    calibratejoy();
 else {
	 putw(0,config);     // joystick off
	 putw(0,config);
	 putw(0,config);
	 putw(0,config);
	 putw(0,config);     // xrange,yrange,scale
	 putw(0,config);
	 putw(0,config);
	}
if (language==ENGLISH)
 printf("\n\nDo you have a Soundblaster? (Y/N)");
else
 printf("\n\nHaben Sie einen Soundblaster? (J/N)");

 ch=toupper(getche());
if ( ((language==ENGLISH)& (ch=='Y')) | ((language==GERMAN) & (ch=='J')) )
	 {
         if (language==ENGLISH)
      	   printf("\n\n\nRefer to your SoundBlaster installation software\nfor port and interrupt information.\n");
         else 
           printf("\n\n\nDie Informationen ber den Interrupt und den \nPort des Soundblaster finden Sie mit der\nmitgelieferten Soundblaster Software.\n ");
	 putw(1,config);


         if (language==ENGLISH)
            {
             printf("\nWhich I/O port is the Soundblaster installed in?");
	     printf("\n(A) 210\n(B) 220\n(C) 230\n(D) 240\n(E) 250\n(F) 260");
             printf("\n\nPick a letter:");
            }
         else 
           {
            printf("\nAuf welcher I/O Adresse ist der Soundblaster installiert?");
	    printf("\n(A) 210\n(B) 220\n(C) 230\n(D) 240\n(E) 250\n(F) 260");
            printf("\n\nBuchstabe angeben:");
            }
	 ch=toupper(getche());
	 switch (ch) {
	   case 'A': ct_io_addx=0x210; break;
	   case 'B': ct_io_addx=0x220; break;
	   case 'C': ct_io_addx=0x230; break;
	   case 'D': ct_io_addx=0x240; break;
	   case 'E': ct_io_addx=0x250; break;
	   case 'F': ct_io_addx=0x260; break;
	   }
	 putw(ct_io_addx,config);
        if (language==ENGLISH)
         {
	 printf("\n\nWhich interrupt is the Soundblaster installed on? (2,3,5,7)");
	 printf("\nInterrupt #");
         }
         else
         {
	 printf("\n\nAuf welchem Interrupt ist der Soundblaster installiert? (2,3,5,7)");
	 printf("\nInterrupt Nummer:");
         }
	 scanf("%u",&ct_int_num);
	 putw(ct_int_num,config);
	 }
else
 {

if (language==ENGLISH)
 printf("\n\nDo you want PC speaker sound? (Y/N)");
else
 printf("\n\nMchten Sie den PC Quker Sound? (J/N)");

 ch=toupper(getche());
if ( ((language==ENGLISH)& (ch=='Y')) | ((language==GERMAN) & (ch=='J')) )
     {
	 putw(2,config);
	 putw(0,config);
	 putw(0,config);
     }
     else
       {
	 putw(0,config);
	 putw(0,config);
	 putw(0,config);
       }
}
if (language==ENGLISH)
 printf("\n\nDo you want to change the game speed? (Y/N)");
else
 printf("\n\nMchten Sie die Spielgeschwindigkeit ndern? (J/N)");

 ch=toupper(getche());
if ( ((language==ENGLISH)& (ch=='Y')) | ((language==GERMAN) & (ch=='J')) )
 {
if (language==ENGLISH)
 printf("\n\nNew speed: (0 is fastest):");
else
 printf("\n\nNeue Geschwindigkeit: (0 ist am schnellsten):");

 scanf("%i",&gs);
 putw(gs,config);
if (language==ENGLISH)
 printf("\n\nNew delay speed for opening effects (0 is default):");
else
 printf("\n\nNeue Verzgerung fr Effekte (0 ist Default):");

 scanf("%i",&gs);
 putw(gs,config);
 }
else 

 {putw(-1,config);
  putw(0,config);}



 fclose(config);
 }
else {
if (language==ENGLISH)
  printf("World Quest Configured");
else
 printf("World Quest konfiguriert! ");
  }
}

void readconfig(void)
{
extern int gamespeed,delspeed;
unsigned int ct1,ct2;
config=fopen("wq.cfg","rb");
	joystickon=getw(config);		// joystick on
	joy.port=getw(config);
	joy.cenx=getw(config);
	joy.ceny=getw(config);
	joy.xrange=getw(config);   
	joy.yrange=getw(config);
	joy.scale=getw(config);
	soundon=getw(config);
	ct1=getw(config);
	ct2=getw(config);
	ct_io_addx=ct1;
	ct_int_num=ct2;
//	printf("%u  %u",ct_io_addx,ct_int_num);
//	getch();
	gamespeed=getw(config);
	if (gamespeed==-1) gamespeed=0;
	delspeed=getw(config);
	if (delspeed<0) delspeed=0;
	fclose(config);
}
