#include <sbc.h>
#include <sbcvoice.h>
#include <conio.h>
#include <dos.h>
#include <math.h>
#include <wgt4.h>
//#include <wgtfli.h>
#include <wgtjoy.h>
#include <wsound.h>

extern int language;
#define ENGLISH 1
#define GERMAN 2
/* These are PC speaker sound effects */
int wshield[42]={
	     40,
	     100,110,120,130,140,
	     130,120,110,100,110,
	     115,120,125,120,115,
	     210,205,200,205,210,
	     200,210,220,250,230,
	     202,206,212,221,225,
	     330,350,302,305,303,
	     407,412,416,420,430};

int pickup[42]={
	     40,
	     400,410,420,430,440,
	     430,420,410,400,410,
	     415,420,425,420,415,
	     410,405,400,405,410,
	     400,410,420,450,430,
	     402,406,412,421,425,
	     430,450,402,405,403,
	     407,412,416,420,430};

int explode[62]={
	     60,
	     300,650,275,825,100,
	     366,234,678,252,250,
	     653,243,653,346,356,
	     653,356,658,234,120,

	     200,550,175,725,50,
	     266,134,578,152,150,
	     553,143,453,246,256,
	     553,256,558,134,120,

	     100,450,75,625,25,
	     166,534,378,452,50,
	     453,43,453,146,287,
	     453,156,458,164,520};

int missilehit[22]={
	     20,
	     100,120,100,140,100,
	     150,120,160,130,100,
	     170,140,100,120,160,
	     140,100,150,110,120};

int shootmissile[7]={
	     5,
	     140,100,150,110,120};


extern wfree_element(unsigned char far *);
extern int delspeed;
void woskew(int,int,block,int [200]);
void calcsin(void);
int lsin[361],lcos[361];
extern int bx,by,tx,ty;
extern int joystickon;
block logo,opening;
int ofs[200];
int ofd[200];
long ofc[200];
long incrate;
int pos[200];
int srate,crate;
color pal[256];
int of;
int hg;
int d;
int pcinitted;

extern int kbdon[35];
extern int kbdscanlist[35];
extern int soundon;
extern int sbon,sbinitted,sbok,sbfminit,i;
static void interrupt (*soldfunc)(); /* interrupt function pointer */
int intkey,origkey;

extern joystick joy;
extern char far *explo1;
extern char far *explo2;
extern char far *shoot1;
extern char far *newweap;
extern char far *die;
extern char far *boom;
extern char far *pman;
extern char far *nweapon;
extern char far *sshield;
extern unsigned char far *thesong;



void waitkey(void)
{
int i;
  if (joystickon==0)
  {
  do {
  if (soundon==1)
   {
  i=sbfm_read_status();
  if (i==0) playcmf(thesong);
  }
 } while (!kbhit());
 getch();
 }
 else
  {
  do {
  if (soundon==1)
   {
  i=sbfm_read_status();
  if (i==0) playcmf(thesong);
  }
 wreadjoystick(&joy);
 } while (joy.buttons==0);
  }
}

void dosound(int num)
{
/*
1 explosion 1
2 explosion 2
3 shoot 1
5 init
6 uninit
7 music repeat
8 get hit
9 chime
10 die
11 boom
12 pick up man
13 new weapon
14 shield
*/
int cntr;
if (soundon==1)
{
if (sbinitted==1)
  {
switch (num)
  {
  case 5: ctvm_stop(); break;
  case 1: ctvm_stop(); plays(explo1); break;
  case 2: ctvm_stop(); plays(explo2); break;
  case 3: ctvm_stop(); plays(shoot1); break;
  case 8: ctvm_stop(); plays(explo1); break;
  case 9: ctvm_stop(); plays(newweap); break;
  case 11: ctvm_stop(); plays(boom); break;
  case 12: ctvm_stop(); plays(pman); break;
  case 13: ctvm_stop(); plays(nweapon); break;
  case 14: ctvm_stop(); plays(sshield); break;
  }
} 
if ((num==5) & (sbinitted==0))
 {
  cntr=0;
  do {
  if (cntr>0)
  ctvm_terminate(); 
  
     sbok=0;

     if (sbc_check_card() & 4)
     {
      if (sbc_scan_int())
	 {
	  if (!ctvm_init())
	       {
	       sbok=1;
	       ctvm_speaker(1) ;
	       }
	  }
       }
   sbinitted=1;
   cntr++;
   }  while ((cntr<=3) & (sbok==0));
       if (sbok==0)
	 {
		wcls(0);
		textmode(C80);
                if (language==ENGLISH)
		 printf("\nError initializing SB driver.\nPlease run again or reboot and retry!\n");
                else
                printf("\nFehler beim Initialiesieren des SB Treibers.\nVersuchen Sie es noch einmal, oder starten Sie den Computer neu!\n");
                ctvm_terminate();
		exit(1);
	}

   }
if ((num==6) & (sbinitted==1))
  {
  ctvm_terminate();
  sbinitted=0;
  }
if ((num==6) & (sbfminit==1))
  {
  sbfm_terminate();
  sbfminit=0;
  }
if ((num==7) & (sbfminit==1))
 {
  i=sbfm_read_status();
  if (i==0) playcmf(thesong);
  }
}
else if (soundon==2)
  {
switch (num)
  {
  case 5: if (pcinitted==0) { winitsnd(200); pcinitted=1;} break;
  case 6: wdeinitsnd(); pcinitted=0; break;
  case 1:
  case 2:
  case 8: loadsnd(explode); break;
  case 3: loadsnd(shootmissile); break;
  case 9: loadsnd(pickup); break;
  case 11: loadsnd(missilehit); break;
  case 12: loadsnd(pickup); break;
  case 13: loadsnd(pickup); break;
  case 14: loadsnd(wshield); break;
  }
 }
}

void interrupt skbd(void)
{
int i,j;

disable();
i=inportb(0x60);
for (j=0; j<35; j++)
   {
   if (i==kbdscanlist[j])
       kbdon[j]=1;
   if (i==kbdscanlist[j]+128)
       kbdon[j]=0;
   }

(* soldfunc)(); /* call old interrupt 9 handler            */
pokeb(0x000,0x041C,intkey);
enable();
}


void sinstallkbd(void)
{
 soldfunc = getvect(0x09);
 setvect(0x09,skbd);
intkey=peekb(0x000,0x041A);
origkey=intkey;
intkey+=2;
if (intkey>58)
   intkey=30;
}


void suninstallkbd(void)
{
setvect(0x09,soldfunc);
pokeb(0x000,0x041A,origkey);
nosound();
}

void woddskew(int x,int y,block blockname,int degrees,int mod, int odd)
{
float newx,offs,slope;
long lnewx,loffs,lslope; // long values converted from floats (speed up)
int ctr;  // y ctr
int hgt,wid,display,shx,of2;
int onewx;

     hgt=wgetblockheight(blockname);
     wid=wgetblockwidth(blockname);
     slope=(float)degrees/45;
     offs=((float)hgt/2)*slope;
     newx=(float)x+offs;
     onewx=newx;
     lnewx=(float)newx*2000;
     lslope=(float)slope*2000;
     for (ctr=y; ctr<y+hgt-1; ctr++)
       {
	if (ctr % mod==odd)
	{
	if (onewx+wid>bx) display=bx+1-onewx; else display=wid;
	if (onewx<tx) {
	   of2=tx-onewx;
	   shx=tx;
	   display=display-of2;
	   } else {
	       shx=onewx;
	       of2=0;
	   }
	 if ((display>0) & (display<=wid) & (ctr>=ty) & (ctr<=by))
	memcpy(&abuf[(ctr)*320+shx],&blockname[(ctr-y)*wid+4+of2],display);
	lnewx=lnewx-lslope;
	onewx=lnewx/2000;
     }
     }
}



void woskew(int x,int y,block blockname,int ot[200])
{
float newx,offs,slope;
long lnewx,loffs,lslope; // long values converted from floats (speed up)
int ctr;  // y ctr
int hgt,wid,display,shx,of2;
int onewx;

     hgt=wgetblockheight(blockname);
     wid=wgetblockwidth(blockname);
     display=wid;
     for (ctr=y; ctr<y+hgt-1; ctr++)
       {
	shx=x+ot[ctr];
	 if ((ctr>=ty) & (ctr<=by))
	memcpy(&abuf[(ctr)*320+shx],&blockname[(ctr-y)*wid+4],display);
     }
}

void calcsin(void)
{
double ox,pcos,psin;
int i;
for (i=0; i<=360; i++)
{
ox=(double)i/180*3.1415*crate;
pcos=cos(ox);
psin=sin(ox);
lcos[i]=(double)(pcos*srate);
lsin[i]=(double)(psin*srate);
}
}


void wsplogo(void)
{
color temppal[256];
extern wgtfont medium;
extern char *registerwq;
extern char *registerfrom;
int i;
srate=40;
crate=2;
if (soundon==1)
      {
        sbfm_init();
	sbfminit=1;
	thesong=lib2buf("wq2.cmf");
	playcmf(thesong);
      }
wcls(0);
logo=wloadcel("logo2.cel",pal);
wsetpalette(0,255,pal);
wreadpalette(0,255,temppal);
wtextcolor(1);
/*for (i=0; i<200; i++)
  {
  wsetcolor(i+20);
  wline(0,i,319,i);
  }
wtextcolor(0);
wtexttransparent(0);
wgtprintf(4,10,NULL,  "            World Quest v1.1            ");
wgtprintf(0,20,NULL,  "             Registered Copy");
wgtprintf(0,40,NULL,  "              Copyright 1993");
wgtprintf(0,50,NULL,  "       WordUp Software Productions");
for (i=15; i<=36; i++)
  registerwq[i]-=3;
wgtprintf(0,80,NULL,"%s",registerwq);
wgtprintf(0,90,NULL," %s",registerfrom);
wgtprintf(4,120,NULL,  "   This is a commercial game. Do NOT");
wgtprintf(4,130,NULL,  "        distribute it please!");

wgtprintf(0,160,NULL,  "      Press any key or fire button");

wtextcolor(1);
wgtprintf(5,11,NULL,  "            World Quest v1.1            ");
wgtprintf(1,21,NULL,  "             Registered Copy");
wgtprintf(1,41,NULL,  "              Copyright 1993");
wgtprintf(1,51,NULL,  "       WordUp Software Productions");
wgtprintf(1,81,NULL,"%s",registerwq);
wgtprintf(1,91,NULL," %s",registerfrom);
wgtprintf(5,121,NULL,  "   This is a commercial game. Do NOT");
wgtprintf(5,131,NULL,  "        distribute it please!");

wgtprintf(0,161,NULL,  "      Press any key or fire button");

do {
if (joystickon==1)
  wreadjoystick(&joy);
if (delspeed>0) delay(delspeed);
wcolrotate(20,250,0,pal);
} while (!kbhit() & (joy.buttons==0));
*/
if (kbhit()) getch();

wcls(0);
wsetpalette(0,255,temppal);
opening=wloadpak("opening.pak");

wcls(0);
calcsin();
window(1,1,80,25);
wputblock(0,0,opening,0);
of=60;

hg=wgetblockheight(logo);

for (i=0; i<hg; i++)
{
d=lcos[i];
ofc[i]=d;
ofs[i+of]=d;
if (i<90) ofd[i]=1;
else if (i<180) ofd[i]=-1;
else ofd[i]=1;
pos[i]=i;
}


do {
for (i=0; i<hg; i++)
{
pos[i]++;
if (pos[i]>360) pos[i]=0;
ofs[i+of]=lcos[pos[i]];
}
woskew(99,of,logo,ofs);
  if (soundon==1)
   {
  i=sbfm_read_status();
  if (i==0) playcmf(thesong);
  }
if (joystickon==1)
  wreadjoystick(&joy);
if (delspeed>0) delay(delspeed);
} while (!kbhit() & (joy.buttons==0));
if (joystickon==0) getch();

wcls(0);
wfree_element(logo);
wfree_element(opening);

}

void titlescreen(void)
{
int xp,yp,i,ox,oy;
block other,tl;
color pal[256];
      vga256();
      wsplogo();

     other=wnewblock(0,0,319,199);
     tl=wloadpak("wq.pak");
     wloadpalette("wq.pal",pal);
     wsetpalette(0,255,pal);
     wsetscreen(other);
     wputblock(0,0,tl,0);

     wnormscreen();
     wcopyscreen(0,47,319,199,other,0,47,NULL);	
     wclip(0,0,319,47);
     for (i=279; i>=0; i--)
	{
	wskew(0,0,other,i);
	if (delspeed>0) delay(delspeed);
	}
     wclip(0,0,319,199);

     waitkey();

     wclip(0,0,319,199);
	wsetcolor(0);
     ox=160;oy=100;
     for (i=97; i>=0; i-=2)
       {
       xp=(i*320/100)/2;
       yp=(i*200/100)/2;
	wsetscreen(other);
	wbar(0,0,319,199);
	wvertres(0,100-yp,100+yp,tl);
	wcopyscreen(0,100-oy,319,100+oy,other,0,100-oy,NULL);
      ox=xp; oy=yp;
      if (delspeed>0) delay(delspeed);
      }
      wnormscreen();
      wcls(0);

     wfree_element(tl);
     wfree_element(other);

}

void gameovers(void)
{
extern block men;
extern int newscore(void);
extern void highscores(void);
int ns;
block game,over,earth;
wfree_element(thesong);
thesong=lib2buf("dead.cmf");
if (soundon==1) playcmf(thesong);
while (kbhit()) getch();
game=wloadcel("game.cel",pal);
over=wloadcel("over.cel",pal);
earth=wloadcel("earth.cel",pal);
wnormscreen();
wcls(0);
wsetpalette(0,255,pal);


for (i=800; i>=0; i-=5)
{
woddskew(107,54,earth,i,2,0);
woddskew(107,54,earth,-i,2,1);
if (delspeed>0) delay(delspeed);
}

for (i=400; i>=0; i-=5)
{
woddskew(73+i,13,game,i,4,0);
woddskew(73+i/2,13,game,i,4,2);
woddskew(73-i,13,game,-i,4,1);
woddskew(73-i/2,13,game,-i,4,3);

woddskew(73+i,136,over,i,4,0);
woddskew(73+i/2,136,over,i,4,2);
woddskew(73-i,136,over,-i,4,1);
woddskew(73-i/2,136,over,-i,4,3);
if (delspeed>0) delay(delspeed);
}
ns=newscore();
if (ns==0) waitkey();

for (i=0; i<=400; i+=5)
{
woddskew(73-i,13,game,0,2,0);
woddskew(73+i,13,game,0,2,1);
if (delspeed>0) delay(delspeed);
}

for (i=0; i<=300; i+=5)
{
woddskew(107-i,54,earth,0,2,0);
woddskew(107+i,54,earth,0,2,1);
if (delspeed>0) delay(delspeed);
}

for (i=0; i<=400; i+=5)
{
woddskew(73-i,136,over,0,2,0);
woddskew(73+i,136,over,0,2,1);
if (delspeed>0) delay(delspeed);
}
wcls(0);
wfree_element(game);
wfree_element(over);
wfree_element(earth);
men=NULL;
if (ns) highscores();
}

